#include "core/pscux_core.h"
#include "sh_var/sh_var3.h"
#include "passer/passer.h"
#include <iostream.h>
#include <stdlib.h>

#define LOOP1 10
#define LOOP2 1234567

#define SSS 20


class Tdata{
public:
  float matriz_float1[SSS][SSS];
  float matriz_float2[SSS][SSS];
  float matriz_float3[SSS][SSS];
  float matriz_float4[SSS][SSS];
  float matriz_float5[SSS][SSS];
  float matriz_float6[SSS][SSS];
  float matriz_float7[SSS][SSS];

  int matriz_int[SSS][SSS];
  int matriz_int2[SSS][SSS];
  char buff[SSS];
  
  Tdata(){
    int i;
    for(i=0 ; i<SSS ; i++ ){
      buff[i] = ' ';
    }
  }
  
  Tdata( char ch ){
    int i;
    for(i=0 ; i<SSS ; i++ ){
      buff[i] = ch;
    }
  }
  
  void show(){
    cout << buff << endl;
  }
};
		  
PscuxSharedVar<Tdata> pshv;

PscuxPasser passer;

Tdata data1('a');
Tdata data2('b');

int func1(int a=1){
  int i=LOOP1;
  int j=LOOP2;
  double x=2;

  cout << "func1" << endl;

  int rec;
  passer.receive( rec );
  cout << "func1 e2" << endl;
  while(1){
    while(j--){
      x++;
      x--;
    }
    //test here
    cout << "func1 setando psvh" << endl;
    pshv << data1;
    j=LOOP2;
  }
  return 1;
}

int func2(int a=1){
  int i=LOOP1;
  int j=LOOP2;
  double x=2;

  cout << "func2" << endl;

  int rec;
  passer.receive( rec );
  cout << "func2 e2" << endl;
  while(1){
    while(j--){
      x++;
      x--;
    }
    //test here
    cout << "func2 setando psvh" << endl;
    pshv << data2;
    j=LOOP2;
  }
  return 2;
}

void sinal(){
  int x=1;
  cout << "aa" << endl;
  passer.send(x);
  cout << "bb" << endl;
}

int main(){
  Tdata result('x');
  cout << "tamanho do pacote: " << sizeof(result) << endl;;
  PscuxJob<int,int> job1(func1,1);
  PscuxJob<int,int> job2(func1,1);
  PscuxJob<int,int> job3(func1,1);
  PscuxJob<int,int> job4(func1,1);
  PscuxJob<int,int> job5(func1,1);
  PscuxJob<int,int> job6(func2,1);
  PscuxJob<int,int> job7(func2,1);
  PscuxJob<int,int> job8(func2,1);
  PscuxJob<int,int> job9(func2,1);
  PscuxJob<int,int> job10(func2,1);

  job1.exec();  job10.exec();
  job2.exec();  job9.exec();
  job3.exec();  job8.exec();
  job4.exec();  job7.exec();
  job5.exec();  job6.exec();

  sinal();
  sinal();
  sinal();
  sinal();
  sinal();
  sinal();
  sinal();
  sinal();
  sinal();
  sinal();

  job1.receive();  job2.receive();
  job3.receive();  job4.receive();
  job5.receive();  job6.receive();
  job7.receive();  job8.receive();
  job9.receive();  job10.receive();

  cout << "valor final de pshv: " << endl; 
  
  result = pshv.get_value();
  
  result.show();
  
  pshv.finalize();
  return 1;
}
