#include <iostream.h>
#include <stdlib.h>
#include "passer/passer.h"
#include "sh_var/sh_var3.h"
#include "core/pscux_core.h"

PscuxSharedVar<char> *shvar;

PscuxPasser *passer;

int func1(int x){
  if( x == 0){
    cout << "this is the last job. sending the term signal by the passer" << endl;
    passer->send(x);
  }
  return 1;
}
int main(int argc , char **argv){
  int jobs;
  int i;

  if(argc < 2){
    cout << "usage: " << argv[0] << " [jobs]" << endl;
    return 0;
  }

  PscuxJob<int,int> *job;
  jobs = atoi(argv[1]);

  while(jobs--){
    cout << "making new job" << endl;
    job = new PscuxJob<int,int>( func1 , jobs );
    passer = new PscuxPasser;
    shvar = new PscuxSharedVar<char>;
    job->exec();
  }
  
  cout << "waiting for term signal..." << endl;
  passer->receive(i);
  cout << "done !! " << endl;
  return 1;
}

  
