#include "pscux.h"
#include <iostream.h>

pscux_mutex mutex;

pscux_shared_var<int> variavel_compartilhada;

struct entrada_processo2{
  int valor;
  int interacoes;
};

int processo1( int interacoes ){
  int i, j;
  j=10;
  for(i=0 ; i<interacoes ; i++ ){
    j++;
    j--;
  }
  return j;
}

char processo2( entrada_processo2 entrada ){
  int i;
  char ch;

  for(i=0 ; i<entrada.interacoes ; i++ ){
    ch=(char)entrada.valor++;
    ch=(char)entrada.valor--;
  }
  return ch;
}

int main(){
  int entrada1;
  entrada_processo2 entrada2;
  
  int resultado1;
  char resultado2;

  pscux_init();

  entrada1 = 100000000;
  entrada2.valor = 65;
  entrada2.interacoes = 100000000;


  Tarefa< int , int > t1( processo1 , entrada1 );
  Tarefa< entrada_processo2 , char > t2( processo2 , entrada2 );

  t1.exec();
  t2.exec();

  resultado1 = t1.receive();
  resultado2 = t2.receive();

  cout << "resultado1: " << resultado1 << endl
       << "resultado2: " << resultado2 << endl;

  return 1;
}
