#include <iostream.h>
#include <stdlib.h>
#include <stl.h>
#include <unistd.h>


template< typename T>
int new_sizeof( T& x ){
  return sizeof(x);
}

typedef struct simple_t{
  int x;
  int y;
}simple_t;

typedef struct complex_t{
  int x;
  char ch;
  char buff[100];
}complex_t;

int main(){
  int aa[2];
  int x;
  int *y;
  int z[10];
  simple_t st;
  complex_t ct;
  void *ptr;

  pipe( aa );
  
  ptr = calloc( 70 , sizeof(char) );

  cout << "\na single \"int\": "
       << new_sizeof(x)
       << "\na \"int\" point: "
       << new_sizeof(y)
       << "\na array to 10 \"int\": "
       << new_sizeof(z)
       << "\na allocated void pointer: "
       << new_sizeof(ptr)
       << "\na simple struct: "
       << new_sizeof(st)
       << "\na complex struct: "
       << sizeof(ct)
       << endl << endl;
  free(ptr);
  x = new_sizeof( ct.ch );
  write( aa[1] , "a" , sizeof( char ) );
  return 0;
}
