#include <errno.h>
#include <fcntl.h>
//#include "globals.h"
#include <unistd.h>

//#include "pipe_server.h"


/* mutex type */
class pscux_mutex{
 public:
  int associated_pipe[2];
  struct flock fl;

  pscux_mutex(){
    pscux_tpipe temp_pipe;
    temp_pipe = pscux_internal_get_new_tpipe();
    associated_pipe = temp_pipe.pipe;
    //pipe( associated_pipe );
    struct flock fl_temp = {  F_WRLCK, SEEK_SET, 0,       0,     0 };
    fl = fl_temp;
  }
  void lock(){
    cout << "trying to lock: " << associated_pipe[1] << endl;
    fl.l_pid = getpid();
    fcntl(associated_pipe[1], F_SETLKW, &fl);
  }
  void unlock(){
    cout << "trying to unlock: " << associated_pipe[1] << endl;
    fl.l_pid = getpid();
    fl.l_type = F_UNLCK;
    fcntl(associated_pipe[1], F_SETLK, &fl);
  }
};
