#include "pscux.h"
#include <iostream.h>
#include <string.h>

struct in_t{
  int x;
  char str1[1024];
  char str2[1024];
  float place;
};

struct out_t{
  int valor;
  char status[1024];
  float result;
};

pscux_mutex my_mutex1;
pscux_shared_var<int> shv1;
pscux_shared_var<int> shv;

out_t processa( in_t isso ){
  out_t resultado;
  //int test_pipe[2];
  int x;

  cout << "dentro de processa"
       << "\nx: " << isso.x
       << "\nstr1: " << isso.str1
       << "\nstr2: " << isso.str2
       << "\n\n";
  resultado.valor = isso.x * 10;
  resultado.result = 3.44;
  strcpy( resultado.status , "OK" );
  
  //pscux_get_new_pipe( test_pipe );
  
  /*
  cout << "received pipe: "
       << endl
       << "\tpipe[0]-> " << test_pipe[0]
       << endl
       << "\tpipe[1]-> " << test_pipe[1]
       << endl;
  */
  x = 120;
  my_mutex1.lock();
  shv.set_value( x );
  my_mutex1.unlock();
  x = 1;
  x = shv.get_value();
  cout << "VALOR DA SH_VAR \"X\": "
       << x
       << endl;
  return resultado;
}


int main(){
  in_t entrada;
  out_t saida;
  
  pscux_init();
  shv.init();
  shv1.init();
  
  entrada.x = 8;
  strcpy( entrada.str1 , "hehehehe" );
  strcpy( entrada.str2 , "hahahaha" );

  Tarefa< in_t , out_t > job1( processa , entrada );
  Tarefa< in_t , out_t > job2( processa , entrada );

  job1.exec();
  //  sleep(1);
  job2.exec();

  saida = job1.receive();
  saida = job2.receive();

  cout << "*=== resultado final ===*"
       << "\n  valor: " << saida.valor
       << "\n  status: " << saida.status
       << "\n  result: " << saida.result
       << "\n\n";
  
  my_mutex1.lock();

  return 0;
}
